<?php
namespace Teknisa\GOP\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Gop11000AprovaOrcaOperacService {
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function beginTransaction() {
        $this->connection->beginTransaction();
    }
    
    public function commit() {
        $this->connection->commit();
    }
    
    public function rollback() {
        $this->connection->rollback();
    }
    
    public function saveAprova($params) {
        $sqlInsert = "
                     INSERT INTO
                        APROVAORCAGOP 
                    (
                        NRORCAMENTOGOP,
                        NRAPROVAORCAGOP,
                        CDOPERADOR,
                        IDAPROVACAOGOP,
                        DSOBSERVACAO,
                        NRORG,
                        DTINCLUSAO,
                        NRORGINCLUSAO,
                        CDOPERINCLUSAO,
                        IDTIPOORCAOP
                     ) 
                    VALUES(
                        :P_NRORCAMENTOGOP,
                        :P_NRAPROVAORCAGOP,
                        :P_CDOPERADOR,
                        :P_IDAPROVACAOGOP,
                        :P_DSOBSERVACAO,
                        :P_NRORG,
                        :P_DTINCLUSAO,
                        :P_NRORGINCLUSAO,
                        :P_CDOPERINCLUSAO,
                        :P_IDTIPOORCAOP
                    )";
        try{
            $std = $this->connection->prepare($sqlInsert);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
    
    public function updateAprova($params) {
        $sqlUpdate = " UPDATE APROVAORCAGOP
                          SET IDAPROVACAOGOP = :P_IDAPROVACAOGOP,
                              DSOBSERVACAO = :P_DSOBSERVACAO,
                              DTULTATU = :P_DTULTATU,
                              NRORGULTATU = :P_NRORGULTATU,
                              CDOPERULTATU = :P_CDOPERULTATU
                        WHERE NRAPROVAORCAGOP = :P_NRAPROVAORCAGOP";
        try{
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
    
    public function updateConclusao($params) {
        $sqlUpdate = "UPDATE CONCPREORCAGOP
                         SET IDSTATUS = :P_IDSTATUS,
                             DSOBSERVACAO = :P_DSOBSERVACAO
                       WHERE CDFILIAL = :P_CDFILIAL
                         AND NRCONCPREORCAGOP = :P_NRCONCPREORCAGOP";
        
        try{
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
}